<?php

include_once(PLX_CORE.'lib/class.plx.msg.php');

/**
 * Plugin commentAuthorOK
 * @author	Suricat
 **/
class commentAuthorOK extends plxPlugin {

	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut
	 * @return	stdio
	 * @author	Suricat
	 **/
	public function __construct($default_lang) {

        # appel du constructeur de la classe plxPlugin (obligatoire)
        parent::__construct($default_lang);

        # déclaration des hooks
		$this->addHook('plxMotorNewCommentaire'         , 'plxMotorNewCommentaire'         );
		$this->addHook('plxMotorDemarrageNewCommentaire', 'plxMotorDemarrageNewCommentaire');
		
        # Autorisation d'acces à la configuration du plugins
		$this-> setConfigProfil(PROFIL_ADMIN);
	}
	
	
	//---------------------------------------------------------------------------------------
	//--- Si l'auteur du commentaire est en liste blanche, la fonction newCommentaire() est -
	//--- courcicuitée pour ne pas effectuer de modération. Elle retourne alors NULL --------
	//---------------------------------------------------------------------------------------
	public function plxMotorNewCommentaire () {
		echo "<?php
		// Récupère la chaine JSON stockant le tableau Author-Email dans le paramétrage du plugin
		// Format de la chaine JSON : [Auteur0,Email0,Auteur1,Email1,Auteur2,Email2,...] 
	    \$StrTAuthorEmail = plxUtils::cdataCheck(trim(\$this->plxPlugins->aPlugins['commentAuthorOK']->getParam('TAuthorEmail')));
	    if(isset(\$StrTAuthorEmail) && strlen(\$StrTAuthorEmail)>2)
		    {
			  // Décodage de la chaine JSON pour en faire un tableau PHP
			  \$TAuthorEmail = json_decode(\$StrTAuthorEmail, true);
			  \$Author = plxUtils::strCheck(trim(\$content['name']));
			  \$Email = (plxUtils::checkMail(trim(\$content['mail']))) ? trim(\$content['mail']) : '';

			  for(\$i=0; \$i<count(\$TAuthorEmail); \$i+=2)
			      {
				    // Si l'auteur du commentaire est dans TAuthorEmail
					// et si l'email correspondant dans TAuthorEmail est vide
					// ou correspond au mail du commentaire, alors pas besoin de modération
				    if(\$TAuthorEmail[\$i]==\$Author &&
					   (strlen(\$TAuthorEmail[\$i+1])==0 ||
					    \$TAuthorEmail[\$i+1]==\$Email))
						{
						  // code identique à la fonction newCommentaire(), mais sans modération
		# On verifie que le capcha est correct
		if(\$this->aConf['capcha'] == 0 OR \$_SESSION['capcha'] == sha1(\$content['rep'])) {
			if(!empty(\$content['name']) AND !empty(\$content['content'])) { # Les champs obligatoires sont remplis
				\$comment=array();
				\$comment['type'] = 'normal';
				\$comment['author'] = plxUtils::strCheck(trim(\$content['name']));
				\$comment['content'] = plxUtils::strCheck(trim(\$content['content']));
				# On verifie le mail
				\$comment['mail'] = (plxUtils::checkMail(trim(\$content['mail'])))?trim(\$content['mail']):'';
				# On verifie le site
				\$comment['site'] = (plxUtils::checkSite(\$content['site'])?\$content['site']:'');
				# On recupere l'adresse IP du posteur
				\$comment['ip'] = plxUtils::getIp();
				# On genere le nom du fichier selon l'existence ou non d'un fichier du meme nom
				\$time = time();
				\$i = 0;
				do { # On boucle en testant l'existence du fichier (cas de plusieurs commentaires/sec pour un article)
					\$i++;
					//////if(\$this->aConf['mod_com']) # On modere le commentaire => underscore
					//////	\$comment['filename'] = '_'.\$artId.'.'.\$time.'-'.\$i.'.xml';
					//////else # On publie le commentaire directement
						\$comment['filename'] =\$artId.'.'.\$time.'-'.\$i.'.xml';
				} while(file_exists(PLX_ROOT.\$this->aConf['racine_commentaires'].\$comment['filename']));
				# On peut creer le commentaire
				if(\$this->addCommentaire(\$comment)) { # Commentaire OK
					//////if(\$this->aConf['mod_com']) # En cours de moderation
					//////	return 'mod';
					//////else # Commentaire publie directement, on retourne son identifiant
						//////return 'c'.\$time.'-'.\$i;
						// Enregistre le retour normal de la fonction newCommentaire() dans le paramétrage du plugin
						\$this->plxPlugins->aPlugins['commentAuthorOK']->setParam('LastCommentIdent', 'c'.\$time.'-'.\$i, 'cdata');
						\$this->plxPlugins->aPlugins['commentAuthorOK']->saveParams(); 
						// return(true) permet de quitter la fonction newCommentaire() et lui fait retourner NULL
						return(true); 
				} else { # Erreur lors de la création du commentaire
					return L_NEWCOMMENT_ERR;
				}
			} else { # Erreur de remplissage des champs obligatoires
				return L_NEWCOMMENT_FIELDS_REQUIRED;
			}
		} else { # Erreur de verification capcha
			return L_NEWCOMMENT_ERR_ANTISPAM;
		}

						  
						}
				  }
			}
		?>";
	}
	
	//---------------------------------------------------------------------------------------
	//--- Rétablissement du retour normal de newCommentaire() si Auteur en liste blanche ----
	//---------------------------------------------------------------------------------------
	public function plxMotorDemarrageNewCommentaire () {
		echo "<?php
		// Si l'auteur du commentaire est en liste blanche, la fonction newCommentaire retourne NULL
		// On récupère alors ce qui aurait dû être retourné (enregistré dans le paramétrage du plugin)
		if(\$retour==NULL)
		    { \$retour=plxUtils::cdataCheck(trim(\$this->plxPlugins->aPlugins['commentAuthorOK']->getParam('LastCommentIdent')));
			}
		?>";
	}
	
}
?>